//+------------------------------------------------------------------+
//|                                                                  |
//|          Compiled by Barry Hendriks - aka Forex-ID10T.           |
//|In no event will author be liable for any damages whatsoever.     |              
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#define ZIGZAG_TREND 0
#define BULL_TREND 1
#define BEAR_TREND -1

#define copyright "#copyright# Barry Hendriks January 2010"
#property link    "http://forex-id10t.jislaaik.com"

extern string Order_Settings = "### EA Config & Settings ###";
extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 1.0;
extern int Slippage = 3;
extern bool UseTakeProfit = true;
extern int TakeProfit = 144;
extern bool UseStopLoss = true;
extern int StopLoss = 233;
extern bool UseTrailingStop = true;
extern int TrailingStop = 34;
extern string  Expert_Settings  = "### BUY/SELL Intelligence ###";
extern int TARGET_SCORE = 20;     //TREND SCORE MUST BE HIGHER THAN THIS - Higher score, less trades.
extern double INCLINE = 1.0025;   //BULL: BAR0_HIGH/BAR1_LOW (2/1 = 2) || BEAR: BAR1_HIGH/BAR0_LOW (2/1 = 2)
                                  //Angle between two successive bars high and low - we want this to be more than 45 degrees.
extern int TOP_SELL = 70;         //70 - 100 = OverBought
extern int BOT_BUY = 30;          //30 - 0 = OverSold
extern double MACD_MAX = 0.0001;  //0 to +0.0001 too LOW
extern double MACD_MIN = -0.0001; //0 to -0.0001 too LOW

double STOH_K, STOH_D;
int BUYs = 0;
int SELLs = 0;

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
   {
   BarCount = Bars;
   
   if(EachTickMode) Current = 0; else Current = 1;
   return(0);
   }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() 
   {
   return(0);
   }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
   {//1
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   
   if(EachTickMode && Bars != BarCount) TickCheck = False;
      Total = OrdersTotal();
      Order = SIGNAL_NONE;
   
      //+------------------------------------------------------------------+
      // Variables for the storage information (data) about the market
      int BULL_SCORE_0 = 0;
      int BEAR_SCORE_0 = 0;
      int ZIGZAG_SCORE_0 = 0;
      string MARKET_TREND = "MARKET_UNDECIDED";
      string comment_line = "";
      
      double Range = 0.00000;
      double Spread = 0.00000;
      Range = High[0] - Low[0];
      Spread = Bid - Ask;
      
      double Bar0_Open = iOpen(NULL,0,Current + 0);
      double Bar1_Open = iOpen(NULL,0,Current + 1);
      double Bar2_Open = iOpen(NULL,0,Current + 2);
      double Bar3_Open = iOpen(NULL,0,Current + 3);
      double Bar5_Open = iOpen(NULL,0,Current + 5);
      double Bar8_Open = iOpen(NULL,0,Current + 8);
      
      double Bar0_Close = iClose(NULL,0,Current + 0);
      double Bar1_Close = iClose(NULL,0,Current + 1);
      double Bar2_Close = iClose(NULL,0,Current + 2);
      double Bar3_Close = iClose(NULL,0,Current + 3);
      double Bar5_Close = iClose(NULL,0,Current + 5);
      double Bar8_Close = iClose(NULL,0,Current + 8);
      
      double Bar0_Low = iLow(NULL,0,Current + 0);
      double Bar1_Low = iLow(NULL,0,Current + 1);
      double Bar2_Low = iLow(NULL,0,Current + 2);
      double Bar3_Low = iLow(NULL,0,Current + 3);
      double Bar5_Low = iLow(NULL,0,Current + 5);
      double Bar8_Low = iLow(NULL,0,Current + 8);
      
      double Bar0_High = iHigh(NULL,0,Current + 0);
      double Bar1_High = iHigh(NULL,0,Current + 1);
      double Bar2_High = iHigh(NULL,0,Current + 2);
      double Bar3_High = iHigh(NULL,0,Current + 3);
      double Bar5_High = iHigh(NULL,0,Current + 5);
      double Bar8_High = iHigh(NULL,0,Current + 8);
      
      double FastMA0 = iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,Current + 0);
      double FastMA1 = iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,Current + 1);
      double FastMA2 = iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,Current + 2);
      double FastMA3 = iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,Current + 3);
      
      double SlowMA0 = iMA(NULL,0,13,0,MODE_EMA, PRICE_CLOSE,Current + 0);
      double SlowMA1 = iMA(NULL,0,13,0,MODE_EMA, PRICE_CLOSE,Current + 1);
      double SlowMA2 = iMA(NULL,0,13,0,MODE_EMA, PRICE_CLOSE,Current + 2);
      double SlowMA3 = iMA(NULL,0,13,0,MODE_EMA, PRICE_CLOSE,Current + 3);
      
      double BBandTop0 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_UPPER,Current + 0);
      double BBandTop1 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_UPPER,Current + 1);
      double BBandTop2 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_UPPER,Current + 2);
      double BBandTop3 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_UPPER,Current + 3);
      
      double BBandBot0 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_LOWER,Current + 0);
      double BBandBot1 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_LOWER,Current + 1);
      double BBandBot2 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_LOWER,Current + 2);
      double BBandBot3 = iBands(NULL,0,13,2,0,PRICE_CLOSE,MODE_LOWER,Current + 3);
      
      double MACD_0 = iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,Current + 0);
      double MACD_1 = iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,Current + 1);
      double MACD_2 = iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,Current + 2);
      double MACD_3 = iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,Current + 3);
      
      double RSI_0 = iRSI(NULL,0,8,6,Current + 0);
      double RSI_1 = iRSI(NULL,0,8,6,Current + 1);
      double RSI_2 = iRSI(NULL,0,8,6,Current + 2);
      double RSI_3 = iRSI(NULL,0,8,6,Current + 3);
      
      double STOH_K_0 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN, Current + 0);
      double STOH_K_1 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN, Current + 1);
      double STOH_K_2 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN, Current + 2);
      double STOH_K_3 = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN, Current + 3);
      
      //+------------------------------------------------------------------+      
      //Set HIGHEST HIGH and LOWEST LOW
      double HIGHEST_HIGH_8, HIGHEST_HIGH_5, HIGHEST_HIGH_3, HIGHEST_HIGH_2, HIGHEST_HIGH_1, HIGHEST_HIGH_0;
      double LOWEST_LOW_8, LOWEST_LOW_5, LOWEST_LOW_3, LOWEST_LOW_2, LOWEST_LOW_1, LOWEST_LOW_0;
      
      HIGHEST_HIGH_8 = HIGHEST_HIGH_5;
      HIGHEST_HIGH_5 = HIGHEST_HIGH_3;
      HIGHEST_HIGH_3 = HIGHEST_HIGH_2;
      HIGHEST_HIGH_2 = HIGHEST_HIGH_1;
      HIGHEST_HIGH_1 = HIGHEST_HIGH_0;
      HIGHEST_HIGH_0 = Bar0_High;
      
      LOWEST_LOW_8 = LOWEST_LOW_5;
      LOWEST_LOW_5 = LOWEST_LOW_3;
      LOWEST_LOW_3 = LOWEST_LOW_2;
      LOWEST_LOW_2 = LOWEST_LOW_1;
      LOWEST_LOW_1 = LOWEST_LOW_0;
      LOWEST_LOW_0 = Bar0_Low;
      
      //+------------------------------------------------------------------+   
      //Set BULL_SCORE & BEAR_SCORES
      if(HIGHEST_HIGH_0 > HIGHEST_HIGH_1) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_0 > HIGHEST_HIGH_2) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_0 > HIGHEST_HIGH_3) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_0 > HIGHEST_HIGH_5) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_0 > HIGHEST_HIGH_8) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_1 > HIGHEST_HIGH_2) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_1 > HIGHEST_HIGH_3) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_1 > HIGHEST_HIGH_5) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_1 > HIGHEST_HIGH_8) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_2 > HIGHEST_HIGH_3) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_2 > HIGHEST_HIGH_5) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_2 > HIGHEST_HIGH_8) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_3 > HIGHEST_HIGH_5) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_3 > HIGHEST_HIGH_8) {BULL_SCORE_0 ++;}
      if(HIGHEST_HIGH_5 > HIGHEST_HIGH_8) {BULL_SCORE_0 ++;}
      
      if(LOWEST_LOW_0 < LOWEST_LOW_1) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_0 < LOWEST_LOW_2) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_0 < LOWEST_LOW_3) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_0 < LOWEST_LOW_5) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_0 < LOWEST_LOW_8) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_1 < LOWEST_LOW_2) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_1 < LOWEST_LOW_3) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_1 < LOWEST_LOW_5) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_1 < LOWEST_LOW_8) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_2 < LOWEST_LOW_3) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_2 < LOWEST_LOW_5) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_2 < LOWEST_LOW_8) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_3 < LOWEST_LOW_5) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_3 < LOWEST_LOW_8) {BEAR_SCORE_0 ++;}
      if(LOWEST_LOW_5 < LOWEST_LOW_8) {BEAR_SCORE_0 ++;}
      
      if(Bar0_Close > Bar1_Close) {BULL_SCORE_0 ++;}
      if(Bar0_Close > Bar2_Close) {BULL_SCORE_0 ++;} 
      if(Bar0_Close > Bar3_Close) {BULL_SCORE_0 ++;} 
      if(Bar0_Close > Bar5_Close) {BULL_SCORE_0 ++;} 
      if(Bar0_Close > Bar8_Close) {BULL_SCORE_0 ++;} 
      if(Bar1_Close > Bar2_Close) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar3_Close) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar5_Close) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar8_Close) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar3_Close) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar5_Close) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar8_Close) {BULL_SCORE_0 ++;}
      if(Bar3_Close > Bar5_Close) {BULL_SCORE_0 ++;}
      if(Bar3_Close > Bar8_Close) {BULL_SCORE_0 ++;}
      if(Bar5_Close > Bar8_Close) {BULL_SCORE_0 ++;}
      
      if(Bar0_Close < Bar1_Close) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar2_Close) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar3_Close) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar5_Close) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar8_Close) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar2_Close) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar3_Close) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar5_Close) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar8_Close) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar3_Close) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar5_Close) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar8_Close) {BEAR_SCORE_0 ++;}
      if(Bar3_Close < Bar5_Close) {BEAR_SCORE_0 ++;}
      if(Bar3_Close < Bar8_Close) {BEAR_SCORE_0 ++;}
      if(Bar5_Close < Bar8_Close) {BEAR_SCORE_0 ++;}
      
      if(Bar0_Open > Bar1_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Open > Bar2_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Open > Bar3_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Open > Bar5_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Open > Bar8_Open) {BULL_SCORE_0 ++;}
      if(Bar1_Open > Bar2_Open) {BULL_SCORE_0 ++;}  
      if(Bar1_Open > Bar3_Open) {BULL_SCORE_0 ++;}  
      if(Bar1_Open > Bar5_Open) {BULL_SCORE_0 ++;}  
      if(Bar1_Open > Bar8_Open) {BULL_SCORE_0 ++;}  
      if(Bar2_Open > Bar3_Open) {BULL_SCORE_0 ++;}  
      if(Bar2_Open > Bar5_Open) {BULL_SCORE_0 ++;}  
      if(Bar2_Open > Bar8_Open) {BULL_SCORE_0 ++;}  
      if(Bar3_Open > Bar5_Open) {BULL_SCORE_0 ++;}  
      if(Bar3_Open > Bar8_Open) {BULL_SCORE_0 ++;}  
      if(Bar5_Open > Bar8_Open) {BULL_SCORE_0 ++;}  
      
      if(Bar0_Open < Bar1_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Open < Bar2_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Open < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Open < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Open < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Open < Bar2_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Open < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Open < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Open < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Open < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Open < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Open < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar3_Open < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar3_Open < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar5_Open < Bar8_Open) {BEAR_SCORE_0 ++;}
      
      if(Bar0_Close > Bar0_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Close > Bar1_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Close > Bar2_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Close > Bar3_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Close > Bar5_Open) {BULL_SCORE_0 ++;}
      if(Bar0_Close > Bar8_Open) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar1_Open) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar2_Open) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar3_Open) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar5_Open) {BULL_SCORE_0 ++;}
      if(Bar1_Close > Bar8_Open) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar2_Open) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar3_Open) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar5_Open) {BULL_SCORE_0 ++;}
      if(Bar2_Close > Bar8_Open) {BULL_SCORE_0 ++;}
      if(Bar3_Close > Bar3_Open) {BULL_SCORE_0 ++;}
      if(Bar3_Close > Bar5_Open) {BULL_SCORE_0 ++;}
      if(Bar3_Close > Bar8_Open) {BULL_SCORE_0 ++;}
      if(Bar5_Close > Bar5_Open) {BULL_SCORE_0 ++;}
      if(Bar5_Close > Bar8_Open) {BULL_SCORE_0 ++;}
      if(Bar8_Close > Bar8_Open) {BULL_SCORE_0 ++;}
      
      if(Bar0_Close < Bar0_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar1_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar2_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar0_Close < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar1_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar2_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar1_Close < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar2_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar2_Close < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar3_Close < Bar3_Open) {BEAR_SCORE_0 ++;}
      if(Bar3_Close < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar3_Close < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar5_Close < Bar5_Open) {BEAR_SCORE_0 ++;}
      if(Bar5_Close < Bar8_Open) {BEAR_SCORE_0 ++;}
      if(Bar8_Close < Bar8_Open) {BEAR_SCORE_0 ++;}
   
      if(Bar0_High > Bar1_High) {BULL_SCORE_0 ++;}
      if(Bar0_High > Bar2_High) {BULL_SCORE_0 ++;}
      if(Bar0_High > Bar3_High) {BULL_SCORE_0 ++;}
      if(Bar0_High > Bar5_High) {BULL_SCORE_0 ++;}
      if(Bar0_High > Bar8_High) {BULL_SCORE_0 ++;}
      if(Bar1_High > Bar2_High) {BULL_SCORE_0 ++;}
      if(Bar1_High > Bar3_High) {BULL_SCORE_0 ++;}
      if(Bar1_High > Bar5_High) {BULL_SCORE_0 ++;}
      if(Bar1_High > Bar8_High) {BULL_SCORE_0 ++;}
      if(Bar2_High > Bar3_High) {BULL_SCORE_0 ++;}
      if(Bar2_High > Bar5_High) {BULL_SCORE_0 ++;}
      if(Bar2_High > Bar8_High) {BULL_SCORE_0 ++;}
      if(Bar3_High > Bar5_High) {BULL_SCORE_0 ++;}
      if(Bar3_High > Bar8_High) {BULL_SCORE_0 ++;}
      if(Bar5_High > Bar8_High) {BULL_SCORE_0 ++;}
      
      if(Bar0_High < Bar1_High) {BEAR_SCORE_0 ++;}
      if(Bar0_High < Bar2_High) {BEAR_SCORE_0 ++;}
      if(Bar0_High < Bar3_High) {BEAR_SCORE_0 ++;}
      if(Bar0_High < Bar5_High) {BEAR_SCORE_0 ++;}
      if(Bar0_High < Bar8_High) {BEAR_SCORE_0 ++;}
      if(Bar1_High < Bar2_High) {BEAR_SCORE_0 ++;}
      if(Bar1_High < Bar3_High) {BEAR_SCORE_0 ++;}
      if(Bar1_High < Bar5_High) {BEAR_SCORE_0 ++;}
      if(Bar1_High < Bar8_High) {BEAR_SCORE_0 ++;}
      if(Bar2_High < Bar3_High) {BEAR_SCORE_0 ++;}
      if(Bar2_High < Bar5_High) {BEAR_SCORE_0 ++;}
      if(Bar2_High < Bar8_High) {BEAR_SCORE_0 ++;}
      if(Bar3_High < Bar5_High) {BEAR_SCORE_0 ++;}
      if(Bar3_High < Bar8_High) {BEAR_SCORE_0 ++;}
      if(Bar5_High < Bar8_High) {BEAR_SCORE_0 ++;}
      
      if(Bar0_Low > Bar1_Low) {BULL_SCORE_0 ++;}
      if(Bar0_Low > Bar2_Low) {BULL_SCORE_0 ++;}
      if(Bar0_Low > Bar3_Low) {BULL_SCORE_0 ++;}
      if(Bar0_Low > Bar5_Low) {BULL_SCORE_0 ++;}
      if(Bar0_Low > Bar8_Low) {BULL_SCORE_0 ++;}
      if(Bar1_Low > Bar2_Low) {BULL_SCORE_0 ++;}
      if(Bar1_Low > Bar3_Low) {BULL_SCORE_0 ++;}
      if(Bar1_Low > Bar5_Low) {BULL_SCORE_0 ++;}
      if(Bar1_Low > Bar8_Low) {BULL_SCORE_0 ++;}
      if(Bar2_Low > Bar3_Low) {BULL_SCORE_0 ++;}
      if(Bar2_Low > Bar5_Low) {BULL_SCORE_0 ++;}
      if(Bar2_Low > Bar8_Low) {BULL_SCORE_0 ++;}
      if(Bar3_Low > Bar5_Low) {BULL_SCORE_0 ++;}
      if(Bar3_Low > Bar8_Low) {BULL_SCORE_0 ++;}
      if(Bar5_Low > Bar8_Low) {BULL_SCORE_0 ++;}
      
      if(Bar0_Low < Bar1_Low) {BEAR_SCORE_0 ++;}
      if(Bar0_Low < Bar2_Low) {BEAR_SCORE_0 ++;}
      if(Bar0_Low < Bar3_Low) {BEAR_SCORE_0 ++;}
      if(Bar0_Low < Bar5_Low) {BEAR_SCORE_0 ++;}
      if(Bar0_Low < Bar8_Low) {BEAR_SCORE_0 ++;}
      if(Bar1_Low < Bar2_Low) {BEAR_SCORE_0 ++;}
      if(Bar1_Low < Bar3_Low) {BEAR_SCORE_0 ++;}
      if(Bar1_Low < Bar5_Low) {BEAR_SCORE_0 ++;}
      if(Bar1_Low < Bar8_Low) {BEAR_SCORE_0 ++;}
      if(Bar2_Low < Bar3_Low) {BEAR_SCORE_0 ++;}
      if(Bar2_Low < Bar5_Low) {BEAR_SCORE_0 ++;}
      if(Bar2_Low < Bar8_Low) {BEAR_SCORE_0 ++;}
      if(Bar3_Low < Bar5_Low) {BEAR_SCORE_0 ++;}
      if(Bar3_Low < Bar8_Low) {BEAR_SCORE_0 ++;}
      if(Bar5_Low < Bar8_Low) {BEAR_SCORE_0 ++;}
      
      if((Bar0_Close < Bar0_Open) && (Bar1_Close > Bar1_Open) && (Bar2_Close < Bar2_Open)) {BULL_SCORE_0 ++;} //BEAR REVERSAL
      if((Bar0_Close < Bar0_Open) && (Bar1_Close < Bar1_Open) && (Bar2_Close > Bar2_Open)) {BULL_SCORE_0 ++;} //BEAR REVERSAL
      
      if((Bar0_Close > Bar0_Open) && (Bar1_Close < Bar1_Open) && (Bar2_Close > Bar2_Open)) {BEAR_SCORE_0 ++;} //BULL REVERSAL
      if((Bar0_Close > Bar0_Open) && (Bar1_Close > Bar1_Open) && (Bar2_Close < Bar2_Open)) {BEAR_SCORE_0 ++;} //BULL REVERSAL
      
      if((Bar0_High / Bar1_Low) > INCLINE) {BULL_SCORE_0 ++;}
      if((Bar0_High / Bar2_Low) > INCLINE) {BULL_SCORE_0 ++;}
      if((Bar0_High / Bar3_Low) > INCLINE) {BULL_SCORE_0 ++;}
      if((Bar1_High / Bar2_Low) > INCLINE) {BULL_SCORE_0 ++;}
      if((Bar1_High / Bar3_Low) > INCLINE) {BULL_SCORE_0 ++;}
      if((Bar2_High / Bar3_Low) > INCLINE) {BULL_SCORE_0 ++;}
      
      if((Bar0_Low / Bar1_High) > INCLINE) {BEAR_SCORE_0 ++;}
      if((Bar0_Low / Bar2_High) > INCLINE) {BEAR_SCORE_0 ++;}
      if((Bar0_Low / Bar3_High) > INCLINE) {BEAR_SCORE_0 ++;}
      if((Bar1_Low / Bar2_High) > INCLINE) {BEAR_SCORE_0 ++;}
      if((Bar1_Low / Bar3_High) > INCLINE) {BEAR_SCORE_0 ++;}
      if((Bar2_Low / Bar3_High) > INCLINE) {BEAR_SCORE_0 ++;}
      
      if(SlowMA0 > SlowMA1) {BULL_SCORE_0 ++;}
      if(SlowMA0 > SlowMA2) {BULL_SCORE_0 ++;}
      if(SlowMA0 > SlowMA3) {BULL_SCORE_0 ++;}
      if(SlowMA1 > SlowMA2) {BULL_SCORE_0 ++;}
      if(SlowMA1 > SlowMA3) {BULL_SCORE_0 ++;}
      if(SlowMA2 > SlowMA3) {BULL_SCORE_0 ++;}
      
      if(SlowMA0 < SlowMA1) {BEAR_SCORE_0 ++;}
      if(SlowMA0 < SlowMA2) {BEAR_SCORE_0 ++;}
      if(SlowMA0 < SlowMA3) {BEAR_SCORE_0 ++;}
      if(SlowMA1 < SlowMA2) {BEAR_SCORE_0 ++;}
      if(SlowMA1 < SlowMA3) {BEAR_SCORE_0 ++;}
      if(SlowMA2 < SlowMA3) {BEAR_SCORE_0 ++;}
      
      if(FastMA0 > FastMA1) {BULL_SCORE_0 ++;}
      if(FastMA0 > FastMA2) {BULL_SCORE_0 ++;}
      if(FastMA0 > FastMA3) {BULL_SCORE_0 ++;}
      if(FastMA1 > FastMA2) {BULL_SCORE_0 ++;}
      if(FastMA1 > FastMA3) {BULL_SCORE_0 ++;}
      if(FastMA2 > FastMA3) {BULL_SCORE_0 ++;}
      
      if(FastMA0 < FastMA1) {BEAR_SCORE_0 ++;}
      if(FastMA0 < FastMA2) {BEAR_SCORE_0 ++;}
      if(FastMA0 < FastMA3) {BEAR_SCORE_0 ++;}
      if(FastMA1 < FastMA2) {BEAR_SCORE_0 ++;}
      if(FastMA1 < FastMA3) {BEAR_SCORE_0 ++;}
      if(FastMA2 < FastMA3) {BEAR_SCORE_0 ++;}
      
      if(FastMA0 > SlowMA0) {BULL_SCORE_0 ++;}
      if(FastMA1 > SlowMA1) {BULL_SCORE_0 ++;}
      if(FastMA2 > SlowMA2) {BULL_SCORE_0 ++;}
      if(FastMA3 > SlowMA3) {BULL_SCORE_0 ++;}
         
      if(FastMA0 < SlowMA0) {BEAR_SCORE_0 ++;}
      if(FastMA1 < SlowMA1) {BEAR_SCORE_0 ++;}
      if(FastMA2 < SlowMA2) {BEAR_SCORE_0 ++;}
      if(FastMA3 < SlowMA3) {BEAR_SCORE_0 ++;}
      
      if(BBandTop0 > BBandTop1) {BULL_SCORE_0 ++;}
      if(BBandTop0 > BBandTop2) {BULL_SCORE_0 ++;}
      if(BBandTop0 > BBandTop3) {BULL_SCORE_0 ++;}
      if(BBandTop1 > BBandTop2) {BULL_SCORE_0 ++;}
      if(BBandTop1 > BBandTop3) {BULL_SCORE_0 ++;}
      if(BBandTop2 > BBandTop3) {BULL_SCORE_0 ++;}
         
      if(BBandTop0 < BBandTop1) {BEAR_SCORE_0 ++;}
      if(BBandTop0 < BBandTop2) {BEAR_SCORE_0 ++;}
      if(BBandTop0 < BBandTop3) {BEAR_SCORE_0 ++;}
      if(BBandTop1 < BBandTop2) {BEAR_SCORE_0 ++;}
      if(BBandTop1 < BBandTop3) {BEAR_SCORE_0 ++;}
      if(BBandTop2 < BBandTop3) {BEAR_SCORE_0 ++;}
      
      if(BBandBot0 > BBandBot1) {BULL_SCORE_0 ++;}
      if(BBandBot0 > BBandBot2) {BULL_SCORE_0 ++;}
      if(BBandBot0 > BBandBot3) {BULL_SCORE_0 ++;}      
      if(BBandBot1 > BBandBot2) {BULL_SCORE_0 ++;}
      if(BBandBot1 > BBandBot3) {BULL_SCORE_0 ++;}
      if(BBandBot2 > BBandBot3) {BULL_SCORE_0 ++;}
         
      if(BBandBot0 < BBandBot1) {BEAR_SCORE_0 ++;}
      if(BBandBot0 < BBandBot2) {BEAR_SCORE_0 ++;}
      if(BBandBot0 < BBandBot3) {BEAR_SCORE_0 ++;}
      if(BBandBot1 < BBandBot2) {BEAR_SCORE_0 ++;}
      if(BBandBot1 < BBandBot3) {BEAR_SCORE_0 ++;}
      if(BBandBot2 < BBandBot3) {BEAR_SCORE_0 ++;}
      
      if(FastMA0 > BBandTop0) {BULL_SCORE_0 ++;}
      if(FastMA1 > BBandTop1) {BULL_SCORE_0 ++;}
      if(FastMA2 > BBandTop2) {BULL_SCORE_0 ++;}
      if(FastMA3 > BBandTop3) {BULL_SCORE_0 ++;}
      
      if(FastMA0 < BBandBot0) {BEAR_SCORE_0 ++;}
      if(FastMA1 < BBandBot1) {BEAR_SCORE_0 ++;}
      if(FastMA2 < BBandBot2) {BEAR_SCORE_0 ++;}
      if(FastMA3 < BBandBot3) {BEAR_SCORE_0 ++;}
      
      if((BBandTop0 - FastMA0) < (FastMA0 - BBandBot0)) {BULL_SCORE_0 ++;}
      if((BBandTop1 - FastMA1) < (FastMA1 - BBandBot1)) {BULL_SCORE_0 ++;}
      if((BBandTop2 - FastMA2) < (FastMA2 - BBandBot2)) {BULL_SCORE_0 ++;}
      if((BBandTop3 - FastMA3) < (FastMA3 - BBandBot3)) {BULL_SCORE_0 ++;}
      
      if((BBandTop0 - FastMA0) > (FastMA0 - BBandBot0)) {BEAR_SCORE_0 ++;}
      if((BBandTop1 - FastMA1) > (FastMA1 - BBandBot1)) {BEAR_SCORE_0 ++;}
      if((BBandTop2 - FastMA2) > (FastMA2 - BBandBot2)) {BEAR_SCORE_0 ++;}
      if((BBandTop3 - FastMA3) > (FastMA3 - BBandBot3)) {BEAR_SCORE_0 ++;}
      
      if(MACD_0 > MACD_1) {BULL_SCORE_0 ++;}
      if(MACD_0 > MACD_2) {BULL_SCORE_0 ++;}
      if(MACD_0 > MACD_3) {BULL_SCORE_0 ++;}
      if(MACD_1 > MACD_2) {BULL_SCORE_0 ++;}
      if(MACD_1 > MACD_3) {BULL_SCORE_0 ++;}
      if(MACD_2 > MACD_3) {BULL_SCORE_0 ++;}
      
      if(MACD_0 < MACD_1) {BEAR_SCORE_0 ++;}
      if(MACD_0 < MACD_2) {BEAR_SCORE_0 ++;}
      if(MACD_0 < MACD_3) {BEAR_SCORE_0 ++;}
      if(MACD_1 < MACD_2) {BEAR_SCORE_0 ++;}
      if(MACD_1 < MACD_3) {BEAR_SCORE_0 ++;}
      if(MACD_2 < MACD_3) {BEAR_SCORE_0 ++;}
      
      if(MACD_0 >= MACD_MAX) {BULL_SCORE_0 ++;}
      if(MACD_1 >= MACD_MAX) {BULL_SCORE_0 ++;}
      if(MACD_2 >= MACD_MAX) {BULL_SCORE_0 ++;}
      if(MACD_3 >= MACD_MAX) {BULL_SCORE_0 ++;}
         
      if(MACD_0 <= MACD_MIN) {BEAR_SCORE_0 ++;}
      if(MACD_1 <= MACD_MIN) {BEAR_SCORE_0 ++;}
      if(MACD_2 <= MACD_MIN) {BEAR_SCORE_0 ++;}
      if(MACD_3 <= MACD_MIN) {BEAR_SCORE_0 ++;}
      
      if(RSI_0 > RSI_1) {BULL_SCORE_0 ++;}
      if(RSI_0 > RSI_2) {BULL_SCORE_0 ++;}
      if(RSI_0 > RSI_3) {BULL_SCORE_0 ++;}
      if(RSI_1 > RSI_2) {BULL_SCORE_0 ++;}
      if(RSI_1 > RSI_3) {BULL_SCORE_0 ++;}
      if(RSI_2 > RSI_3) {BULL_SCORE_0 ++;}
      
      if(RSI_0 < RSI_1) {BEAR_SCORE_0 ++;}
      if(RSI_0 < RSI_2) {BEAR_SCORE_0 ++;}
      if(RSI_0 < RSI_3) {BEAR_SCORE_0 ++;}
      if(RSI_1 < RSI_2) {BEAR_SCORE_0 ++;}
      if(RSI_1 < RSI_3) {BEAR_SCORE_0 ++;}
      if(RSI_2 < RSI_3) {BEAR_SCORE_0 ++;}
       
      if(RSI_0 >= TOP_SELL) {BULL_SCORE_0 ++;}
      if(RSI_1 >= TOP_SELL) {BULL_SCORE_0 ++;}
      if(RSI_2 >= TOP_SELL) {BULL_SCORE_0 ++;}
      if(RSI_3 >= TOP_SELL) {BULL_SCORE_0 ++;}
      
      if(RSI_0 <= BOT_BUY) {BEAR_SCORE_0 ++;}
      if(RSI_1 <= BOT_BUY) {BEAR_SCORE_0 ++;}
      if(RSI_2 <= BOT_BUY) {BEAR_SCORE_0 ++;}
      if(RSI_3 <= BOT_BUY) {BEAR_SCORE_0 ++;}
      
      if(STOH_K_0 > STOH_K_1) {BULL_SCORE_0 ++;}
      if(STOH_K_0 > STOH_K_2) {BULL_SCORE_0 ++;}
      if(STOH_K_0 > STOH_K_3) {BULL_SCORE_0 ++;}
      if(STOH_K_1 > STOH_K_2) {BULL_SCORE_0 ++;}
      if(STOH_K_1 > STOH_K_3) {BULL_SCORE_0 ++;}
      if(STOH_K_2 > STOH_K_3) {BULL_SCORE_0 ++;}
         
      if(STOH_K_0 < STOH_K_1) {BEAR_SCORE_0 ++;}
      if(STOH_K_0 < STOH_K_2) {BEAR_SCORE_0 ++;}
      if(STOH_K_0 < STOH_K_3) {BEAR_SCORE_0 ++;}
      if(STOH_K_1 < STOH_K_2) {BEAR_SCORE_0 ++;}
      if(STOH_K_1 < STOH_K_3) {BEAR_SCORE_0 ++;}
      if(STOH_K_2 < STOH_K_3) {BEAR_SCORE_0 ++;}
      
      if(STOH_K_0 > (TOP_SELL - 10)) {BULL_SCORE_0 ++;}
      if(STOH_K_1 > (TOP_SELL - 10)) {BULL_SCORE_0 ++;}
      if(STOH_K_2 > (TOP_SELL - 10)) {BULL_SCORE_0 ++;}
      if(STOH_K_3 > (TOP_SELL - 10)) {BULL_SCORE_0 ++;}
         
      if(STOH_K_0 < (BOT_BUY + 10)) {BEAR_SCORE_0 ++;}
      if(STOH_K_1 < (BOT_BUY + 10)) {BEAR_SCORE_0 ++;}   
      if(STOH_K_2 < (BOT_BUY + 10)) {BEAR_SCORE_0 ++;}      
      if(STOH_K_3 < (BOT_BUY + 10)) {BEAR_SCORE_0 ++;}      
      
      //+------------------------------------------------------------------+   
      //Set ZIGZAG_SCORE
      if((HIGHEST_HIGH_0 - LOWEST_LOW_0) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((HIGHEST_HIGH_1 - LOWEST_LOW_1) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((HIGHEST_HIGH_2 - LOWEST_LOW_2) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((HIGHEST_HIGH_3 - LOWEST_LOW_3) < Spread) {ZIGZAG_SCORE_0 ++;}
         
      if((Bar0_High - Bar0_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      if((Bar0_High - Bar1_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      if((Bar0_High - Bar2_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      if((Bar0_High - Bar3_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      if((Bar1_High - Bar1_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      if((Bar1_High - Bar2_Low) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((Bar1_High - Bar3_Low) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((Bar2_High - Bar2_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      if((Bar2_High - Bar3_Low) < Spread) {ZIGZAG_SCORE_0 ++;} 
      
      if((BBandTop0 - BBandBot0) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop0 - BBandBot1) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop0 - BBandBot2) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop0 - BBandBot3) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop1 - BBandBot1) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop1 - BBandBot2) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop1 - BBandBot3) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop2 - BBandBot2) < Spread) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop2 - BBandBot3) < Spread) {ZIGZAG_SCORE_0 ++;}
      
      if((BBandTop0 < BBandTop1) && (BBandBot0 > BBandBot1)) {ZIGZAG_SCORE_0 ++;}
      if((BBandTop0 < BBandTop2) && (BBandBot0 > BBandBot2)) {ZIGZAG_SCORE_0 ++;} 
      if((BBandTop0 < BBandTop3) && (BBandBot0 > BBandBot3)) {ZIGZAG_SCORE_0 ++;} 
      if((BBandTop1 < BBandTop2) && (BBandBot1 > BBandBot2)) {ZIGZAG_SCORE_0 ++;}  
      if((BBandTop1 < BBandTop3) && (BBandBot1 > BBandBot3)) {ZIGZAG_SCORE_0 ++;}  
      if((BBandTop2 < BBandTop3) && (BBandBot2 > BBandBot3)) {ZIGZAG_SCORE_0 ++;}  
      
      if((MACD_0 < MACD_MAX) && (MACD_0 > MACD_MIN)) {ZIGZAG_SCORE_0 ++;}
      if((MACD_1 < MACD_MAX) && (MACD_1 > MACD_MIN)) {ZIGZAG_SCORE_0 ++;}
      if((MACD_2 < MACD_MAX) && (MACD_2 > MACD_MIN)) {ZIGZAG_SCORE_0 ++;}
         
      if((RSI_0 < TOP_SELL) && (RSI_0 > BOT_BUY)) {ZIGZAG_SCORE_0 ++;}
      if((RSI_1 < TOP_SELL) && (RSI_1 > BOT_BUY)) {ZIGZAG_SCORE_0 ++;}
      if((RSI_2 < TOP_SELL) && (RSI_2 > BOT_BUY)) {ZIGZAG_SCORE_0 ++;}
         
      if((STOH_K_0 > (BOT_BUY + 10)) && (STOH_K_0 < (TOP_SELL - 10))) {ZIGZAG_SCORE_0 ++;}
      if((STOH_K_1 > (BOT_BUY + 10)) && (STOH_K_1 < (TOP_SELL - 10))) {ZIGZAG_SCORE_0 ++;}
      if((STOH_K_2 > (BOT_BUY + 10)) && (STOH_K_2 < (TOP_SELL - 10))) {ZIGZAG_SCORE_0 ++;}
         
      //+------------------------------------------------------------------+   
      //Check if ZIGZAG TREND and set final MARKET_TREND for trading signal
      if(ZIGZAG_SCORE_0 > 15) BULL_SCORE_0 = (BULL_SCORE_0 - 15);
      if(ZIGZAG_SCORE_0 > 15) BEAR_SCORE_0 = (BEAR_SCORE_0 - 15);
         
      if((BULL_SCORE_0 > TARGET_SCORE) && (BULL_SCORE_0 > BEAR_SCORE_0)) {MARKET_TREND = "BULL_TREND";}
      if((BEAR_SCORE_0 > TARGET_SCORE) && (BEAR_SCORE_0 > BULL_SCORE_0)) {MARKET_TREND = "BEAR_TREND";}
      if(ZIGZAG_SCORE_0 > 15) {MARKET_TREND = "ZIGZAG_TREND";}
         
      //+------------------------------------------------------------------+      
      //Display Market Info on chart and set BUY/SELL and EXIT signals
      string BuySellAlert = "To be determined ... ";
      string OrderSignal = "SIGNAL_NONE";
         
      //if((RSI_0 > TOP_SELL) && (STOH_K > (TOP_SELL + 10)) && (RSI_0 < RSI_2) && (STOH_K_0 < STOH_K_2) && (MACD_0 > MACD_MAX) && (MACD_0 < MACD_2) && (HIGHEST_HIGH_0 < HIGHEST_HIGH_3)) 
      if(BEAR_SCORE_0 > 90) {
         Order = SIGNAL_SELL;
         BuySellAlert = "SELL";
         SELLs ++;
      }
      //if((RSI_0 < BOT_BUY) && (STOH_K < (BOT_BUY - 10)) && (RSI_0 > RSI_2) && (STOH_K_0 > STOH_K_2) && (MACD_0 < MACD_MIN) && (MACD_0 > MACD_2) && (LOWEST_LOW_0 > LOWEST_LOW_5)) 
      if(BEAR_SCORE_0 == 80) {
         Order = SIGNAL_CLOSESELL;
         BuySellAlert = "CLOSE_SELL";
      }
      //if((RSI_0 < BOT_BUY) && (STOH_K < (BOT_BUY - 10)) && (RSI_0 > RSI_2) && (STOH_K_0 > STOH_K_2) && (MACD_0 < MACD_MIN) && (MACD_0 > MACD_2) && (LOWEST_LOW_0 > LOWEST_LOW_3))
      if(BULL_SCORE_0 > 90) {
         Order = SIGNAL_BUY;
         BuySellAlert = "BUY";
         BUYs ++;
      }
      //if((RSI_0 > TOP_SELL) && (STOH_K > (TOP_SELL + 10)) && (RSI_0 < RSI_2) && (STOH_K_0 < STOH_K_2) && (MACD_0 > MACD_MAX) && (MACD_0 < MACD_2) && (HIGHEST_HIGH_0 < HIGHEST_HIGH_5)) 
      if(BULL_SCORE_0 == 80) {
         Order = SIGNAL_CLOSEBUY;
         BuySellAlert = "CLOSE_BUY";
      }
      //if((RSI_0 > BOT_BUY) && (RSI_0 < TOP_SELL) || (STOH_K > (BOT_BUY - 10)) && (STOH_K < (TOP_SELL + 10))) 
      if(BULL_SCORE_0 < 80 && BEAR_SCORE_0 < 80) {
         Order = SIGNAL_NONE;
         BuySellAlert = "Analyzing signal ... ";
      }
      
      if(Order == SIGNAL_NONE) OrderSignal = "SIGNAL_NONE";            //0
      if(Order == SIGNAL_BUY) OrderSignal = "SIGNAL_BUY";              //1
      if(Order == SIGNAL_SELL) OrderSignal = "SIGNAL_SELL";            //2
      if(Order == SIGNAL_CLOSEBUY) OrderSignal = "SIGNAL_CLOSEBUY";    //3
      if(Order == SIGNAL_CLOSESELL) OrderSignal = "SIGNAL_CLOSESELL";  //4
   
      comment_line=("HIGH-----------:>" + HIGHEST_HIGH_0 + "\n" + "LOW------------:>" + LOWEST_LOW_0 + "\n" 
                  + "HiLoRange----:>" + Range + "\n" + "RSI--------------:>" + RSI_0 + "\n" + "STOH----------:>" + STOH_K_0 + "\n" 
                  + "MACD----------:>" + MACD_0 + "\n" + "BULL------------:>" + BULL_SCORE_0 + "\n" + "BEAR----------:>" + BEAR_SCORE_0 + "\n" 
                  + "ZIGZAG-------:>" + ZIGZAG_SCORE_0 + "\n" + "Trend----------:>" + MARKET_TREND + "\n" + "Transaction---:>" + BuySellAlert + "\n" 
                  + "OrderSignal--:>" + OrderSignal + "\n" + "Nr of BUYs---:>" + BUYs + "\n" + "Nr of SELLs--:>" + SELLs);
      Comment(comment_line); 
      
      //Check position
      bool IsTrade = False;
      
      for (int i = 0; i < Total; i ++) {//2
          OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
          if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {//3
             IsTrade = True;
             if(OrderType() == OP_BUY) {//4
                //Close
                if(Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {//5
                   OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
                   if(!EachTickMode) BarCount = Bars;
                      IsTrade = False;
                      continue;
                }//5
                //Trailing stop
                if(UseTrailingStop && TrailingStop > 0) {//5                 
                   if(Bid - OrderOpenPrice() > Point * TrailingStop) {//6
                      if(OrderStopLoss() < Bid - Point * TrailingStop) {//7
                         OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                         if(!EachTickMode) BarCount = Bars;
                            continue;
                      }//7
                   }//6
                }//5
                } else {
                //Close
                if(Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))){//5
                   OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
                   if(!EachTickMode) BarCount = Bars;
                      IsTrade = False;
                      continue;
                }//5
                //Trailing stop
                if(UseTrailingStop && TrailingStop > 0) {//5                 
                   if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {//6
                      if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {//7
                         OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                         if(!EachTickMode) BarCount = Bars;
                            continue;
                      }//7
                   }//6
                }//5
             }//4
          }//3
      }//2 - FOR LOOP
      
      //Buy
      if(Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {//2
         if(!IsTrade) {//3
            //Check free margin
            if(AccountFreeMargin() < (1000 * Lots)) {//4
               Print("We have no money. Free Margin = ", AccountFreeMargin());
               return(0);
            }//4
            if(UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
            if(UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
            
            Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
            if(Ticket > 0) {//4
               if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {//5
                  Print("BUY order opened : ", OrderOpenPrice());
               } else {
                  Print("Error opening BUY order : ", GetLastError());
               }//5
            }//4
            if(EachTickMode) TickCheck = True;
            if(!EachTickMode) BarCount = Bars;
              return(0);
         }//3
      }//2
      //Sell
      if(Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {//2
         if(!IsTrade) {//3
            //Check free margin
            if(AccountFreeMargin() < (1000 * Lots)) {//4
               Print("We have no money. Free Margin = ", AccountFreeMargin());
               return(0);
            }//4
            if(UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
            if(UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;
            
            Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
            if(Ticket > 0) {//4
               if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {//5
		            Print("SELL order opened : ", OrderOpenPrice());
			      } else {
			         Print("Error opening SELL order : ", GetLastError());
			      }//5
            }//4
            if(EachTickMode) TickCheck = True;
            if(!EachTickMode) BarCount = Bars;
              return(0);
         }//3
      }//2
      if(!EachTickMode) BarCount = Bars;
         return(0);
    }//1    

